Loading...
Searching...
No Matches
LeafData< FpN, CoordT, MaskT, LOG2DIM > Struct Template Reference

`#include <nanovdb/NanoVDB.h>`

Inheritance diagram for LeafData< FpN, CoordT, MaskT, LOG2DIM >:

## Public Types

using | BaseT = LeafFnBase< CoordT, MaskT, LOG2DIM >
using | BuildType = FpN
using | ValueType = float
using | FloatType = float

## Public Member Functions

uint8_t | bitWidth () const
size_t | memUsage () const
float | getValue (uint32_t i) const
| LeafData ()=delete
| This class cannot be constructed or deleted.
| LeafData (const LeafData &)=delete
LeafData & | operator= (const LeafData &)=delete
| ~LeafData ()=delete
void | init (float min, float max, uint8_t bitWidth)
void | setOn (uint32_t offset)
float | getMin () const
| return the quantized minimum of the active values in this node
float | getMax () const
| return the quantized maximum of the active values in this node
float | getAvg () const
| return the quantized average of the active values in this node
float | getDev () const
| return the quantized standard deviation of the active values in this node
void | setMin (float min)
void | setMax (float max)
void | setAvg (float avg)
void | setDev (float dev)
template<typename T >
void | setOrigin (const T &ijk)

## Static Public Member Functions

static constexpr uint32_t | padding ()
static size_t | memUsage (uint32_t bitWidth)
static uint64_t | memUsage ()
static bool | hasStats ()

## Public Attributes

CoordT | mBBoxMin
uint8_t | mBBoxDif [3]
uint8_t | mFlags
MaskT< LOG2DIM > | mValueMask
float | mMinimum
float | mQuantum
uint16_t | mMin
uint16_t | mMax
uint16_t | mAvg
uint16_t | mDev

## Static Public Attributes

static constexpr bool | FIXED_SIZE = false

## Member Typedef Documentation

## BaseT

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

using BaseT = LeafFnBase<CoordT, MaskT, LOG2DIM>

## BuildType

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

using BuildType = FpN

## FloatType

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

using FloatType = float

inherited

## ValueType

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

using ValueType = float

inherited

## Constructor & Destructor Documentation

## LeafData() [1/2]

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData | ( |  | ) |

delete

This class cannot be constructed or deleted.

## LeafData() [2/2]

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData | ( | const LeafData< FpN, CoordT, MaskT, LOG2DIM > & |  | ) |

delete

## ~LeafData()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

~LeafData | ( |  | ) |

delete

## Member Function Documentation

## bitWidth()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint8_t bitWidth | ( |  | ) | const

inline

## getAvg()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

float getAvg | ( |  | ) | const

inlineinherited

return the quantized average of the active values in this node

## getDev()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

float getDev | ( |  | ) | const

inlineinherited

return the quantized standard deviation of the active values in this node

Note
  0 <= StdDev <= max-min or 0 <= StdDev/(max-min) <= 1

## getMax()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

float getMax | ( |  | ) | const

inlineinherited

return the quantized maximum of the active values in this node

## getMin()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

float getMin | ( |  | ) | const

inlineinherited

return the quantized minimum of the active values in this node

## getValue()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

float getValue | ( | uint32_t | i | ) | const

inline

## hasStats()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

static bool hasStats | ( |  | ) |

inlinestaticinherited

## init()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

void init | ( | float | min,
|  | float | max,
|  | uint8_t | bitWidth
| ) |  |

inlineinherited

## memUsage() [1/3]

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

static uint64_t memUsage | ( |  | ) |

inlinestaticinherited

## memUsage() [2/3]

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

size_t memUsage | ( |  | ) | const

inline

## memUsage() [3/3]

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

static size_t memUsage | ( | uint32_t | bitWidth | ) |

inlinestatic

## operator=()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData & operator= | ( | const LeafData< FpN, CoordT, MaskT, LOG2DIM > & |  | ) |

delete

## padding()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

static constexpr uint32_t padding | ( |  | ) |

inlinestaticconstexpr

## setAvg()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setAvg | ( | float | avg | ) |

inlineinherited

Note
  min <= avg <= max or 0 <= (avg-min)/(min-max) <= 1

## setDev()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setDev | ( | float | dev | ) |

inlineinherited

Note
  0 <= StdDev <= max-min or 0 <= StdDev/(max-min) <= 1

## setMax()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setMax | ( | float | max | ) |

inlineinherited

Note
  min <= X <= max or 0 <= (X-min)/(min-max) <= 1

## setMin()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setMin | ( | float | min | ) |

inlineinherited

Note
  min <= X <= max or 0 <= (X-min)/(min-max) <= 1

## setOn()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setOn | ( | uint32_t | offset | ) |

inlineinherited

## setOrigin()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>
template<typename T >

void setOrigin | ( | const T & | ijk | ) |

inlineinherited

## Member Data Documentation

## FIXED_SIZE

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

constexpr bool FIXED_SIZE = false

staticconstexpr

## mAvg

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint16_t mAvg

inherited

## mBBoxDif

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint8_t mBBoxDif[3]

inherited

## mBBoxMin

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

CoordT mBBoxMin

inherited

## mDev

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint16_t mDev

inherited

## mFlags

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint8_t mFlags

inherited

## mMax

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint16_t mMax

inherited

## mMin

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint16_t mMin

inherited

## mMinimum

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

float mMinimum

inherited

## mQuantum

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

float mQuantum

inherited

## mValueMask

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

MaskT<LOG2DIM> mValueMask

inherited